% This script designs the example for the test of signs used in 
% de Paula and Tang (2011).
% delta is the scale parameter that controls the size of the interaction
% effect; S is an array specifying the discrete support of the regressors
% EQ is the matrix summarizing equilibrium prob for each given state
% flag is a dummy to show the equilibrium is in the interior of the cube 
% [0,1]^3.
% Warning: when flag == 1, the algorithm does not apply !
function [EQ, flag] = CalEQ3(delta,S); 
EQ = []; 

% delta_i(x) = delta*x0*xi, u_i(x)=x0+xi, F_i_x is unif(-c,c) 
% where c = 2*(abs(delta*x0*xi)+x0+xi)
for X0 = S{1}, for X1 = S{2}, for X2 = S{3}, for X3 = S{4},
    D  = [X0*X1; X0*X2; X0*X3]; U = [X0+X1; X0+X2; X0+X3]; C  = 2.*(abs(D)+U);
    A = [2*C(1) -delta*D(1) -delta*D(1); -delta*D(2) 2*C(2) -delta*D(2); ...
        -delta*D(3) -delta*D(3) 2*C(3)];
    B = [U(1)+C(1); U(2)+C(2); U(3)+C(3)];
    p = A\B; p = p';
    EQ = [EQ ; X0 X1 X2 X3 p];
end;    end;    end;    end;
flag = max(max((double(EQ(:,[5 6 7]))>1|double(EQ(:,[5 6 7]))<0),[],2));