function f = FindCV(I,M,alpha,S);
% M is a K-by-K matrix; I is a vector with dim <= k <=K; 
% This function forms a sub-matrix of M corresponding to I and 
% finds the critical value of the max of the absolute value of the 
% corresponding multivariate normal. 
TempM   = M(I,:); 
SubM    = TempM(:,I);
SimData = mvnrnd(zeros(1,length(I)), SubM, S); 
MAM     = max(abs(SimData),[],2);  
f       = prctile(MAM,alpha*100); 