% This m-script finds the critical values in RW2005 through bootstrap.
function f = NP_FindCV(I,D,alpha,S,T,flag);
% S is the number of bootstrap sample to take.
% T is the statistic calculated from the estimating sample.
% D is the estimating sample.
% I is the index of the hypotheses not rejected so far.
% flag = 1 if the studentized approach is taken, = 0 otherwise.
N       = size(D,1); 
% BDSV is the vector of statistics calculated using the bootstrap data
BDSV    = zeros(S,1);
for s   = 1:S,
    BSInd  = randsample(N,N,true);
    BD     = D(BSInd,:);
    [BT,BVar,BStdev]  = CalT(BD);
    if  flag    == 1, 
         BDSV(s) = max(N^.5*(abs(BT(I)-T(I))./BStdev(I)));
    else BDSV(s) = max(abs(BT(I)-T(I)));
    end;
end;
f = prctile(BDSV,alpha*100);